require 'find'
require 'logger'

logger = Logger.new STDOUT

module Metaverse
  class Iterator

    def initialize rootPath, ignore, repos = []
      @logger = Logger.new STDOUT
      @ignore = ['.', 'bower_components', 'node_modules'] + ignore
      @rootPath = rootPath
      @repos = repos
    end

    def build 
      Find.find(@rootPath) do |path|
        if File.directory? path
          if @ignore.any? { |word| File.basename(path).include? word }
            Find.prune
          end
        end

        if File.directory? path + '/.git'
          @repos << path
        end

      end
      puts "#{@repos.length} repos loaded"
      @repos
    end

    def each &block
      @repos.send(:each, &block)
    end

    def map &block
      @repos.send(:map, &block)
    end

    def empty?
      @repos.count == 0
    end
  end
end